<?php
/**
 * @package    JBusinessDirectory
 *
 * @author CMSJunkie http://www.cmsjunkie.com
 * @copyright  Copyright (C) 2007 - 2021 CMSJunkie. All rights reserved.
 * @license   https://www.gnu.org/licenses/agpl-3.0.en.html
 */
defined('_JEXEC') or die('Restricted access');
use Joomla\Utilities\ArrayHelper;

require_once BD_CLASSES_PATH.'/traits/OneToMany.php';

jimport('joomla.application.component.modeladmin');
/**
 * Company Model for Companies.
 *
 */
class JBusinessDirectoryModelTax extends JModelAdmin {

	use OneToMany;

	/**
	 * @var        string    The prefix to use with controller messages.
	 * @since   1.6
	 */
	protected $text_prefix = 'COM_JBUSINESSDIRECTORY_TAX';

	/**
	 * Model context string.
	 *
	 * @var        string
	 */
	protected $_context = 'com_jbusinessdirectory.tax';

	public function __construct($config = array()) {
		$this->appSettings = JBusinessUtil::getApplicationSettings();
	
		parent::__construct($config);
	}
	
	/**
	 * Method to test whether a record can be deleted.
	 *
	 * @param   object    A record object.
	 *
	 * @return  boolean  True if allowed to delete the record. Defaults to the permission set in the component.
	 */
	protected function canDelete($record) {
		return true;
	}

	/**
	 * Method to test whether a record can be deleted.
	 *
	 * @param   object    A record object.
	 *
	 * @return  boolean  True if allowed to change the state of the record. Defaults to the permission set in the component.
	 */
	protected function canEditState($record) {
		return true;
	}

	/**
	 * Returns a Table object, always creating it
	 *
	 * @param   type    The table type to instantiate
	 * @param   string    A prefix for the table class name. Optional.
	 * @param   array  Configuration array for model. Optional.
	 * @return  JTable    A database object
	 */
	public function getTable($type = 'Taxes', $prefix = 'Table', $config = array()) {
		return JTable::getInstance($type, $prefix, $config);
	}

	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since   1.6
	 */
	protected function populateState() {
		$app = JFactory::getApplication('administrator');

		// Load the User state.
		$id = JFactory::getApplication()->input->getInt('id');
		$this->setState('tax.id', $id);
	}

	/**
	 * Method to get a menu item.
	 *
	 * @param   integer    The id of the menu item to get.
	 *
	 * @return  mixed  Menu item data object on success, false on failure.
	 */
	public function &getItem($itemId = null) {
		$itemId = (!empty($itemId)) ? $itemId : (int)$this->getState('tax.id');
		$false = false;

		// Get a menu item row instance.
		$table = $this->getTable();

		// Attempt to load the row.
		$return = $table->load($itemId);

		// Check for a table object error.
		if ($return === false && $table->getError()) {
			$this->setError($table->getError());
			return $false;
		}

		$properties = $table->getProperties(1);
		$value = ArrayHelper::toObject($properties, 'JObject');
		$value->services = JBusinessUtil::getAvailablePayableServices();

		$taxServicesTable  = $this->getTable('TaxServices', 'JTable');
		$value->selectedServices = $taxServicesTable->getTaxServices($itemId);

		$taxCountriesTable       = $this->getTable('TaxCountries', 'JTable');
		$value->countryAmounts   = $taxCountriesTable->getTaxCountries($itemId);

		return $value;
	}

	/**
	 * Method to get the menu item form.
	 *
	 * @param   array  $data		Data for the form.
	 * @param   boolean	$loadData	True if the form is to load its own data (default case), false if not.
	 * @return  JForm	A JForm object on success, false on failure
	 * @since   1.6
	 */
	public function getForm($data = array(), $loadData = true) {
		exit;
		// The folder and element vars are passed when saving the form.
		if (empty($data)) {
			$item		= $this->getItem();
			// The type should already be set.
		}
		// Get the form.
		$form = $this->loadForm('com_jbusinessdirectory.tax', 'item', array('control' => 'jform', 'load_data' => $loadData), true);
		if (empty($form)) {
			return false;
		}

		return $form;
	}

	/**
	 * Method to get the data that should be injected in the form.
	 *
	 * @return  mixed  The data for the form.
	 * @since   1.6
	 */
	protected function loadFormData() {
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_jbusinessdirectory.edit.tax.data', array());

		if (empty($data)) {
			$data = $this->getItem();
		}

		return $data;
	}


	/**
	 * Method to save the form data.
	 *
	 * @param   array  The form data.
	 * @return  boolean  True on success.
	 */
	public function save($data) {
		$id	= (!empty($data['id'])) ? $data['id'] : (int) $this->getState('tax.id');
		if (empty($data['id'])) {
			$data['id'] = 0;
		}
		$isNew = true;

		$defaultLng = JBusinessUtil::getLanguageTag();
		$input = JFactory::getApplication()->input;
		$tax_name = $input->get("name_".$defaultLng, '', 'RAW');
		$tax_description = $input->get("description_".$defaultLng, '', 'RAW');

		if (!empty($tax_name) && empty($data["tax_name"])) {
			$data["tax_name"] = $tax_name;
		}

		if (!empty($tax_description) && empty($data["tax_description"])) {
			$data["tax_description"] = $tax_description;
		}

		if (isset($data["tax_amount"])) {
			$data["tax_amount"] =  floatval($data["tax_amount"]);
		}
		
		// Get a row instance.
		$table = $this->getTable();

		// Load the row if saving an existing item.
		if ($id > 0) {
			$table->load($id);
			$isNew = false;
		}

		// Bind the data.
		if (!$table->bind($data)) {
			$this->setError($table->getError());
			return false;
		}

		// Check the data.
		if (!$table->check()) {
			$this->setError($table->getError());
			return false;
		}

		// Store the data.
		if (!$table->store()) {
			$this->setError($table->getError());
			return false;
		}

		$this->setState('tax.id', $table->id);

		if ($this->appSettings->enable_multilingual) {
			JBusinessDirectoryTranslations::saveTranslations(TAX_DESCRIPTION_TRANSLATION, $table->id, 'description_');
		}

		$this->saveTaxServices($data);

		try {
			$this->saveOneToManyChildren([
				"parentId"                    => $this->getState('tax.id'),
				"parentField"                 => "tax_id",
				"childrenTable"               => "tax_countries",
			], $data);
		} catch (Exception $e) {
			$this->setError($e->getMessage());
		}

		// Clean the cache
		$this->cleanCache();

		return true;
	}

	public function saveTaxServices($data) {
		$serviceIds  = $data["servicesId"];
		$taxId = (int) $this->getState('tax.id');
		$table       = $this->getTable("TaxServices", 'JTable');
		$table->deleteTaxServices($taxId);

		foreach ($serviceIds as $i => $serviceId) {
			if (!empty($serviceId)) {
				$tableFields               = $this->getTable("TaxServices", 'JTable');
				$tableFields->tax_id       = $taxId;
				$tableFields->app_id       = $serviceId;
				if (!$tableFields->check()) {
					$application = JFactory::getApplication();
					$application->enqueueMessage($tableFields->getError(), 'error');
					return false;
				}
				if (!$tableFields->store()) {
					$application = JFactory::getApplication();
					$application->enqueueMessage($tableFields->getError(), 'error');
					return false;
				}
			}
		}
		return true;
	}


	/**
	 * Method to delete groups.
	 *
	 * @param   array  An array of item ids.
	 * @return  boolean  Returns true on success, false on failure.
	 */
	public function delete(&$itemIds) {
		// Sanitize the ids.
		$itemIds = (array) $itemIds;
		ArrayHelper::toInteger($itemIds);

		// Get a group row instance.
		$table = $this->getTable();

		// Iterate the items to delete each one.
		foreach ($itemIds as $itemId) {
			if (!$table->delete($itemId)) {
				$this->setError($table->getError());
				return false;
			}
		}

		// Clean the cache
		$this->cleanCache();

		return true;
	}

	/**
	 * Method that retrieves all countries
	 *
	 * @return array of countries
	 *
	 * @since 5.5.0
	 */
	public function getCountries() {
		$table = $this->getTable('Country', 'JTable');
		$countries = $table->getCountries();

		return $countries;
	}
}
